/*
 * @author Ranides Atterwim <ranides@gmail.com>
 * @copyright Ranides Atterwim
 * @license WTFPL
 * @url http://ranides.net/projects/assira
 */
package net.ranides.assira.collection.lookups;

import net.ranides.assira.generic.HashUtils;
import java.util.Map;
import net.ranides.assira.collection.utils.HashCollection;

/**
 * A type-specific hash map with primitive int values.
 */
@SuppressWarnings({
    "PMD.AvoidReassigningParameters"
})
public final class IdentLookup<K> extends AHashLookup<K> {

    private static final long serialVersionUID = 3L;

    /**
     * Creates a new hash map.
     *
     * <p>The actual table size will be the least power of two greater than
     * <code>expected</code>/
     * <code>f</code>.
     *
     * @param expected the expected number of elements in the hash set.
     * @param factor the load factor.
     */
    @SuppressWarnings("unchecked")
    public IdentLookup(int expected, float factor) {
        super(expected, factor);
    }

    /**
     * Creates a new hash map with {@link Hash#DEFAULT_LOAD_FACTOR} as load
     * factor.
     *
     * @param expected the expected number of elements in the hash map.
     */
    public IdentLookup(int expected) {
        this(expected, HashCollection.LOAD_FACTOR);
    }

    /**
     * Creates a new hash map with initial expected
     * {@link Hash#DEFAULT_INITIAL_SIZE} entries and
     * {@link Hash#DEFAULT_LOAD_FACTOR} as load factor.
     */
    public IdentLookup() {
        this(HashCollection.INITIAL_SIZE, HashCollection.LOAD_FACTOR);
    }

    /**
     * Creates a new hash map copying a given one.
     *
     * @param values a {@link Map} to be copied into the new hash map.
     * @param factor the load factor.
     */
    public IdentLookup(Map<? extends K, ? extends Integer> values, float factor) {
        this(values.size(), factor);
        putAll(values);
    }

    /**
     * Creates a new hash map with {@link Hash#DEFAULT_LOAD_FACTOR} as load
     * factor copying a given one.
     *
     * @param values a {@link Map} to be copied into the new hash map.
     */
    public IdentLookup(Map<? extends K, ? extends Integer> values) {
        this(values, HashCollection.LOAD_FACTOR);
    }

    /**
     * Creates a new hash map copying a given type-specific one.
     *
     * @param values a type-specific map to be copied into the new hash map.
     * @param factor the load factor.
     */
    public IdentLookup(IdentLookup<K> values, float factor) {
        this(values.size(), factor);
        putAll(values);
    }

    /**
     * Creates a new hash map with {@link Hash#DEFAULT_LOAD_FACTOR} as load
     * factor copying a given type-specific one.
     *
     * @param values a type-specific map to be copied into the new hash map.
     */
    public IdentLookup(IdentLookup<K> values) {
        this(values, HashCollection.LOAD_FACTOR);
    }

    /**
     * Creates a new hash map using the elements of two parallel arrays.
     *
     * @param keys the array of keys of the new hash map.
     * @param values the array of corresponding values in the new hash map.
     * @param factor the load factor.
     * @throws IllegalArgumentException if <code>k</code> and <code>v</code>
     * have different lengths.
     */
    public IdentLookup(K[] keys, int values[], float factor) {
        this(keys.length, factor);
        if (keys.length != values.length) {
            throw new IllegalArgumentException("The key array and the value array have different lengths (" + keys.length + " and " + values.length + ")");
        }
        for (int i = 0; i < keys.length; i++) {
            this.put(keys[ i], values[ i]);
        }
    }

    /**
     * Creates a new hash map with {@link Hash#DEFAULT_LOAD_FACTOR} as load
     * factor using the elements of two parallel arrays.
     *
     * @param keys the array of keys of the new hash map.
     * @param values the array of corresponding values in the new hash map.
     * @throws IllegalArgumentException if <code>k</code> and <code>v</code>
     * have different lengths.
     */
    public IdentLookup(K[] keys, int[] values) {
        this(keys, values, HashCollection.LOAD_FACTOR);
    }
    
    @Override
    protected int hash(K key) {
        try {
            return key == null ? 0x87fcd5c : HashUtils.murmurHash3(System.identityHashCode(key));
        } catch(ClassCastException ex) {
            // "unchecked" generic methods could pass something strange here
            return 0;
        }
    }

    @Override
    protected boolean compare(K key1, K key2) {
        return key1 == key2; // NOPMD : identity
    }
}
